import sys
import dill
import pandas


def exec_by_fun_reducer(args):
    output_iro_path = args[1]
    input_iro_prefix = args[2]
    num_iros = int(args[3])

    try:
        with open("{0}{1}.iro".format(input_iro_prefix, 0), "rb") as out_data_file:
            out_data_final_df = dill.load(out_data_file)

        columns_order = out_data_final_df.columns.tolist()

        for iro_id in range(1, num_iros):
            with open("{0}{1}.iro".format(input_iro_prefix, iro_id), "rb") as out_data_file:
                out_data_df = dill.load(out_data_file)
            out_data_final_df = out_data_final_df.append(out_data_df, ignore_index=True)

        with open(output_iro_path, "wb") as output_iro_file:
            dill.dump(out_data_final_df[columns_order], output_iro_file)
    except Exception as e:
        sys.stderr.write("{0}\n".format(str(e)))
        sys.exit(1)

if __name__ == '__main__':
    exec_by_fun_reducer(sys.argv)
