import sys
import dill
import os


def exec_by_fun_result_preparer(args):
    result_dir = args[1]
    out_data_name = args[2]
    is_zip = args[3] in ("true", "True")

    if is_zip:
        def func(output_dir, zip_file_name):
            import dill
            import os
            import re
            import zipfile

            with zipfile.ZipFile(os.path.join(output_dir, zip_file_name), "r") as zip_file:
                zip_file.extractall(output_dir)

            iro_file_names = [file for file in os.listdir(output_dir) if re.match("iroFile.*iro", file)]

            with open(os.path.join(output_dir, iro_file_names[0]), "rb") as out_data_file:
                ret_object = dill.load(out_data_file)

            columns_order = ret_object.columns.tolist()

            for iro_file_name in iro_file_names[1:]:
                with open(os.path.join(output_dir, iro_file_name), "rb") as out_data_file:
                    out_data = dill.load(out_data_file)
                ret_object = ret_object.append(out_data, ignore_index=True)

            return ret_object[columns_order]

        func_params = {"zip_file_name": out_data_name}
    else:
        def func(output_dir, fro_file_name):
            import dill
            import os

            with open(os.path.join(output_dir, fro_file_name), "rb") as fro_file:
                ret_object = dill.load(fro_file)
            return ret_object

        func_params = {"fro_file_name": out_data_name}

    job_object = {"func": func, "funcParams": func_params}
    with open(os.path.join(result_dir, "job.pyOutData"), "wb") as job_out_file:
        dill.dump(job_object, job_out_file)


if __name__ == '__main__':
    exec_by_fun_result_preparer(sys.argv)
