import sys
from revoscalepy.RxSerializable import rx_native_call
from revoscalepy.utils.RxTrace import RxTraceLevel
from revoscalepy.utils.RxTrace import rx_runtime_trace


def reducer(args, _native_call_function) :

    fro_path           = args[1]
    iro_base_name_path = args[2]
    iro_files_size     = int(args[3])
    # TO DO : remove name_node and port
    name_node        = args[4]
    port            = args[5]
    trace_level      = int(args[6])
    process_type     = 'WORKER'
    log_dir          = args[7] 

    rx_runtime_trace("start", RxTraceLevel.INFO)

    try:
        if trace_level > 0:
            call_params = {
                              'USE':'InitializeLogging',
                              'traceLevel':trace_level,
                              'processType':process_type,
                              'logDir':log_dir
                          }
            _native_call_function(functionname='Util', params=call_params)

        iro_seq = range(0, iro_files_size)
        iro_paths = list()

        for seq in iro_seq:
            iro_paths.append(iro_base_name_path + str(seq) + ".iro")

        rx_runtime_trace("update iro", RxTraceLevel.INFO)
        call_params = {
                          'USE':'UpdateIRO',
                          'fullPath':iro_paths,
                          'inHdfs':False
                      }
        _native_call_function(functionname='Util', params=call_params)

        rx_runtime_trace("write iro", RxTraceLevel.INFO)
        call_params = {
                          'USE':'WriteIRO',
                          'outputObjectPath':fro_path,
                          'outputInHdfs':False
                      }
        _native_call_function(functionname='Util', params=call_params)

    except Exception as e:
        print(e)
        sys.exit(1)

    rx_runtime_trace("finish", RxTraceLevel.INFO)

if __name__ == "__main__":
    reducer(sys.argv, rx_native_call)
