#!/bin/bash

# --- defaults ---------------------------------------------------------
USER="%user%"
SESSION_PID="%sessionPid%"
APP_ID="%appId%"
JOB_GUID="%jobGUID%"
WAIT="%wait%"
MRS_HADOOP_PATH="%mrsHadoopPath%"

# --- command-line options ---------------------------------------------
while [ "$1" != "" ]; do
  case "$1" in
    --jobGUID )       shift
                      JOB_GUID=$1
                      ;;
    --user )          shift
                      USER=$1
                      ;;
    --sessionPid )    shift
                      SESSION_PID=$1
                      ;;
    --appId )         shift
                      APP_ID=$1
                      ;;
    --wait )          shift
                      WAIT=$1
                      ;;
    --mrsHadoopPath ) shift
                      MRS_HADOOP_PATH=$1
                      ;;
    --scope )         shift
                      SCOPE=$1
                      ;;
    * )               ;;
  esac
  shift
done

HADOOP_FOLDER_PATH=$(dirname "$(readlink -nf ${MRS_HADOOP_PATH})")
KILLER_PATH=${HADOOP_FOLDER_PATH}/workflow/common/RevoSparkSubmitKiller

# --- script logic -----------------------------------------------------
${KILLER_PATH} ${USER} ${SESSION_PID} ${APP_ID} ${JOB_GUID} ${WAIT} kill ${SCOPE}

