#!/bin/bash

# --- defaults ---------------------------------------------------------
CLUSTER_GUID_DIR="%clusterGUIDDir%"
USER="%user%"
SESSION_PID="%sessionPid%"
APP_ID="%appId%"
JOB_GUID="%jobGUID%"
WAIT="%wait%"
MRS_HADOOP_PATH="%mrsHadoopPath%"


# --- command-line options ---------------------------------------------
while [ $# -gt 0 ]; do
  case "$1" in
    -clusterGUIDDir)  CLUSTER_GUID_DIR="$2"; shift 2;;
    -jobGUID)         JOB_GUID="$2"; shift 2;;
    -user)            USER="$2"; shift 2;;
    -sessionPid)      SESSION_PID="$2"; shift 2;;
    -appId)           APP_ID="$2"; shift 2;;
    -wait)            WAIT="$2"; shift 2;;
    -mrsHadoopPath)   MRS_HADOOP_PATH="$2"; shift 2;;
    *) echo "WARNING! unknown option $1"; shift;;
  esac
done

HADOOP_FOLDER_PATH=$(dirname "$(readlink -nf ${MRS_HADOOP_PATH})")
KILLER_PATH=${HADOOP_FOLDER_PATH}/workflow/common/RevoSparkSubmitKiller

# --- script logic -----------------------------------------------------


set -- $(<${CLUSTER_GUID_DIR}/jobIdentifier.txt)
MYJOBID=$1
NOEXITDUMMY=$(source ${CLUSTER_GUID_DIR}/get-job-status.sh)
set -- $(<${CLUSTER_GUID_DIR}/jobStatus.txt)
MYSTATE=$1
if [ $MYSTATE == "running" ] || [ $MYSTATE == "queued" ] || [ $MYSTATE == "undetermined" ]
then
    ${KILLER_PATH} ${USER} ${SESSION_PID} ${APP_ID} ${JOB_GUID} ${WAIT} kill app
    kill -9 $MYJOBID
    MYUUID=$(cat /proc/sys/kernel/random/uuid)
    echo "canceled" > ${CLUSTER_GUID_DIR}/$MYUUID
    mv ${CLUSTER_GUID_DIR}/$MYUUID ${CLUSTER_GUID_DIR}/jobStatus.txt
fi
