library(jsonlite)
args <- commandArgs(trailingOnly = TRUE)
dir <- args[1]
src.dir <- args[2]
command <- args[3]

env <- fromJSON(file.path(dir,"env-final.json"))
job <- fromJSON(file.path(dir,"job.json"))
job.type = job["jobType"]
job.guid = job['jobGUID']

fillTemplate <- function(template.file.name, out.file.name) {
  template <- paste(readLines(file.path(src.dir, "..", "templates", template.file.name)), collapse = "\n")

  for (key in names(env)) {
    if (key == "extraConfig") {
      template <- gsub(paste0("%",key,"%"), gsub("\"","%DOUBLEQUOTE%", env[key]), template)
    } else {
      template <- gsub(paste0("%",key,"%"), env[key], template)
    }
  }

  template <- gsub(paste0("%jobGUID%"), job["jobGUID"], template)
  template <- gsub(paste0("%clusterGUIDDir%"), dir, template)

  write(template, file.path(dir, out.file.name))
}

if ( command == "connect" ) {
  fillTemplate("spark-connect-template.sh", "spark-connect.sh")
}
if ( command == "disconnect" ) {
  fillTemplate("spark-disconnect-template.sh", "spark-disconnect.sh")
}
if ( command == "applist" ) {
  fillTemplate("spark-list-template.sh", "spark-list.sh")
}
if ( command == "run" ) {
  fillTemplate("spark-start-job-template.sh", "start-job.sh")
  fillTemplate("spark-kill-job-template.sh", "kill-job.sh")
  fillTemplate("spark-get-job-status-template.sh", "get-job-status.sh")
  fillTemplate("spark-create-job-output-template.sh", "create-job-output.sh")
}
